#include "manalink.h"

int card_platinum_angel(int player, int card, event_t event){
    // 004C48A0
    // if my life is 0 or less, then set life to 1 and remember how much 
    // damage was prevented
    card_instance_t *instance = get_card_instance(player, card);
    if( life[player] < 1 && instance->info_slot != -1 ){
        add_ccounters(player, card, 1-life[player]);
        life[player] = 1;
        instance->info_slot = count_ccounters(player, card);
    }
    
    // take life back when this leaves play
    if( comes_into_play(player, card, event) ){
        instance->info_slot = 0;
    }
    if( leaves_play(player, card, event) ){
        life[player] -= instance->info_slot;
        instance->info_slot = -1;
    }
    
    // if we are at 0 cards and we would draw a card, instead draw a
    // Sliver token
    int *deck = deck_ptr[player];
    if( count_deck(player) == 0 ){
        if( event == EVENT_DRAW_PHASE ){
            event_result -= 99;
        }
        if( trigger_condition == TRIGGER_REPLACE_CARD_DRAW && affect_me(player, card) && reason_for_trigger_controller == player){
            int id = get_internal_card_id_from_csv_id( get_id_by_name("Sliver") );
            deck[0] = id;
        }
    
        // remove any slivers from hand
        int i;
        for(i=0;i<active_cards_count[player]; i++){
            card_instance_t *instance2 = get_card_instance(player, i);
            if( ! ( instance2->state & STATE_INVISIBLE ) && ! ( instance2->state & STATE_IN_PLAY )  ){
                if( get_id(player, i ) == get_id_by_name("Sliver") ){
                    instance2->state |= STATE_INVISIBLE;
                }
            }
        }
    }
    
    // AI cannot block with this
    if( player == AI ){
        cannot_block(player, card, event);
    }
    
    return 0;
}

int card_darksteel_colossus(int player, int card, event_t event){
    if( event == EVENT_GRAVEYARD_ABILITY ){
        remove_card_from_grave(player, card);
        int *deck = deck_ptr[player];
        deck[ count_deck(player) ] = get_internal_card_id_from_csv_id( get_id_by_name("Darksteel Colossus") ); 
        shuffle(player);
    }
    else{
        indestructible(player, card, event);
    }
    return 0;
}

int card_bottle_gnomes(int player, int card, event_t event){
  switch(event){
    case EVENT_CAN_ACTIVATE:
      return 1;
      break;
    case EVENT_ACTIVATE:
      kill_card(player, card, KILL_SACRIFICE);
      break;
    case EVENT_RESOLVE_ACTIVATION:
      gain_life(player, 3);
      break;
	default:
	  break;
  }
  return 0;
}

int card_phyrexian_dreadnought(int player, int card, event_t event){
    if( comes_into_play(player, card, event) ){
        card_instance_t *instance = get_card_instance(player, card);
        instance->state |= STATE_CANNOT_TARGET;
            
        target_definition_t td;
        default_target_definition(player, card, &td, TYPE_CREATURE);
        td.allowed_controller = player;
        td.preferred_controller = player;
        td.illegal_abilities = 0;
        int total_power = 0;
        
        int i=0;
        while( can_target(&td) && spell_fizzled != 1 ){
            if( i > 0 ){
                instance->targets[12] = instance->targets[0];
            }
            if( pick_target(&td, "LORD_OF_THE_PIT") ){
                card_instance_t *target = get_card_instance(instance->targets[0].player, instance->targets[0].card);
                target->state |= STATE_CANNOT_TARGET;
                if( i > 0 ){
                    instance->targets[i] = instance->targets[0];
                    instance->targets[0] = instance->targets[12];
                }
                i++;
            }
            else if (i > 0 ){
                instance->targets[0] = instance->targets[12];
            }
         }
        
        int j=0;
        for(j=0;j<i;j++){
            total_power += get_power( instance->targets[j].player, instance->targets[j].card);
            kill_card( instance->targets[j].player, instance->targets[j].card, KILL_SACRIFICE);
        }
        if( total_power < 12 ){
            kill_card(player, card, KILL_SACRIFICE);
        }
        
        instance->state &= ~STATE_CANNOT_TARGET;
    }
    return 0;
}


