#include "manalink.h"

int monocolor_hybrid(int player, int card, event_t event){
    card_instance_t *instance = get_card_instance(player, card);
    int card_color = cards_data[ instance->internal_card_id ].color;
    int color = 0;
    if( card_color & COLOR_TEST_BLACK ){
        color = COLOR_BLACK;
    }
    else if( card_color & COLOR_TEST_BLUE ){
        color = COLOR_BLUE;
    }
    else if( card_color & COLOR_TEST_GREEN ){
        color = COLOR_GREEN;
    }
    else if( card_color & COLOR_TEST_RED ){
        color = COLOR_RED;
    }
    else{
        color = COLOR_WHITE;
    }
       
    
    int colors[6];
    card_ptr_t* c = cards_ptr[ get_id( player, card ) ];
    int hybrid_cost = c->req_colorless / 2;
    int i;
    for(i=0;i<6;i++){
        colors[i]=0;
    }
    
    if( event == EVENT_MODIFY_COST ){
        for ( i =hybrid_cost;i>=0;i--){
            colors[ color ] = i;
            colors[ 0 ] = 2 * (hybrid_cost - i);        
            if( has_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5] ) ){
                // make the spell free
                COST_COLORLESS -= c->req_colorless;
                return 0;
            }
        }
    }
    else if( event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        //if( ! was_card_in_hand(player, card) ){ return 0; }
        for ( i =hybrid_cost;i>=0;i--){
            colors[ color ] = i;
            colors[ 0 ] = 2 * (hybrid_cost - i);  
            if( has_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5]  ) ){
                cancel = 0; 
                charge_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5]  );
                if( cancel != 1 ){ return 0; }
            }
        }
    }
    return 0;
}
        
        

int hybrid(int player, int card, event_t event){
    // determine what out 2 colors are based on the card color
    card_instance_t *instance = get_card_instance(player, card);
    int card_color = cards_data[ instance->internal_card_id ].color;
    
    int color1 = 0;
    int color2 = 0;
    if( card_color & COLOR_TEST_BLACK ){
        color1 = COLOR_BLACK;
    }
    if( card_color & COLOR_TEST_BLUE ){
        if( color1 ){
            color2 = COLOR_BLUE;
        }
        else{
            color1 = COLOR_BLUE;
        }
    }
    if( card_color & COLOR_TEST_GREEN ){
        if( color1 ){
            color2 = COLOR_GREEN;
        }
        else{
            color1 = COLOR_GREEN;
        }
    }
    if( card_color & COLOR_TEST_RED ){
        if( color1 ){
            color2 = COLOR_RED;
        }
        else{
            color1 = COLOR_RED;
        }
    }
    if( card_color & COLOR_TEST_WHITE ){
        color2 = COLOR_WHITE;
    }   
    
    int colors[6];
    card_ptr_t* c = cards_ptr[ get_id( player, card ) ];
    int hybrid_cost = c->req_blue + c->req_white + c->req_black + c->req_red + c->req_green;
    colors[0] = c->req_colorless;
    int i;
    for(i=1;i<6;i++){
        colors[i]=0;
    }
    
    if( event == EVENT_MODIFY_COST ){
        instance->targets[10].player = 2;
        for ( i =hybrid_cost;i>=0;i--){
            colors[ color1 ] = i;
            colors[ color2 ] = hybrid_cost - i;        
            if( has_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5] ) ){
                // make the spell free
                COST_BLACK -= c->req_black;
                COST_BLUE -= c->req_blue;
                COST_GREEN -= c->req_green;
                COST_RED -= c->req_red;
                COST_WHITE -= c->req_white;
                COST_COLORLESS -= c->req_colorless;
                return 0;
            }
        }
    }
    else if( event == EVENT_CAST_SPELL ){
        if( ! affect_me(player, card) ){ return 0; }
        if( instance->targets[10].player != 2 ){ return 0; }
        
        for ( i =hybrid_cost;i>=0;i--){
            colors[ color1 ] = i;
            colors[ color2 ] = hybrid_cost - i;  
            if( has_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5]  ) ){
                cancel = 0; 
                charge_mana_multi( player, colors[0], colors[1], colors[2], colors[3], colors[4], colors[5]  );
                if( cancel != 1 ){ return 0; }
            }
        }
    }
    return 0;
}

int has_figure_hybrid(int player, int number){
    int i;
    for ( i = number ;i>=0;i--){
        if( has_mana_multi( player, 0, 0, 0, 0, i, number - i  ) ){
            return 1;
        }
    }
    return 0;
}

int charge_figure_hybrid(int player, int number){
    int i;
    for ( i = number ;i>=0;i--){
        if( has_mana_multi( player, 0, 0, 0, 0, i, number - i  ) ){
            cancel = 0; 
            charge_mana_multi( player, 0, 0, 0, 0, i, number - i );
            if( cancel != 1 ){ return 0; }
        }
    }
    return 0;
}             

int card_figure_of_destiny(int player, int card, event_t event){
    hybrid(player, card, event);
    
    card_instance_t *instance = get_card_instance( player, card);
    if( comes_into_play(player, card, event ) == 1 ){
        instance->info_slot = 0;
    }
    
    if( event == EVENT_CAN_ACTIVATE ){
        return has_figure_hybrid(player, 1);
    }
    else if(event == EVENT_ACTIVATE ){
        int choice = 0;
        if( has_figure_hybrid(player, 6) && instance->info_slot > 1 ){
            choice = do_dialog(player, player, card, -1, -1, " Become a 2/2\n Become a 4/4\n Become an 8/8\n", 2);
        }
        else if( has_figure_hybrid(player, 3) && instance->info_slot > 0 ){
            choice = do_dialog(player, player, card, -1, -1, " Become a 2/2\n Become a 4/4", 1);
        }
        
        if( choice == 0 ){
            charge_figure_hybrid(player, 1);
        }
        else if(choice == 1){
            charge_figure_hybrid(player, 3);
        }
        else if(choice == 2){
            charge_figure_hybrid(player, 6);
        }
        if( spell_fizzled != 1 ){
            instance->targets[0].card = choice;
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        card_instance_t *parent = get_card_instance( instance->parent_controller, instance->parent_card  );    
        parent->info_slot = parent->targets[0].card + 1;
    }
    else if( affect_me(player, card ) ){
        if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
            if( instance->info_slot == 1 ){
                event_result++;
            }
            else if( instance->info_slot == 2 ){
                event_result+=3;
            }
            else if( instance->info_slot == 3 ){
                event_result+=7;
            }
        }
        else if( event == EVENT_ABILITIES ){
            if( instance->info_slot == 3 ){
                event_result |= KEYWORD_FLYING;
                event_result |= KEYWORD_FIRST_STRIKE;
            }
        } 
    }
    return 0;
}

int card_manamorphose(int player, int card, event_t event){
    hybrid(player, card, event);
    if(event == EVENT_RESOLVE_SPELL ){  
        card_instance_t *instance = get_card_instance(player, card);
        instance->card_color = 0x3E; // any color
        instance->mana_color = 0x3E;
        add_one_mana_any_color(player, card, event);
        add_one_mana_any_color(player, card, event);
        draw_a_card(player);
        kill_card( player, card, KILL_SACRIFICE);
    }
    else if( event == EVENT_CAN_CAST ){
        return 1;
    }
    return 0;
}

int card_spectral_procession(int player, int card, event_t event){
    if(event == EVENT_CAN_CAST ){
        return 1;
    }
    else if(event == EVENT_RESOLVE_SPELL &&  cancel != 1){
        generate_token(player, "Spirit (white)");
        generate_token(player, "Spirit (white)");
        generate_token(player, "Spirit (white)");
        kill_card(player, card, KILL_DESTROY);
    }

    return monocolor_hybrid(player, card, event);
}

int card_flame_javelin(int player, int card, event_t event){
    monocolor_hybrid(player, card, event);
    if( spell_fizzled != 1 ){
        return card_lightning_blast(player, card, event);
    }
    return 0;
}


int card_wilt_leaf_cavaliers(int player, int card, event_t event){
    vigilance( player, card );
    return hybrid(player, card, event);
}

int card_tattermunge_maniac(int player, int card, event_t event){
    hybrid(player, card, event);
    return attack_if_able(player, card, event);
}

int card_plumeveil(int player, int card, event_t event){
    hybrid(player, card, event);
    return flash(player, card, event);
}

int card_oversoul_of_dusk(int player, int card, event_t event){
    return hybrid(player, card, event);  
}

int card_wistful_selkie(int player, int card, event_t event){
    if(comes_into_play(player, card, event) == 1 ){
        draw_a_card(player);
    }
    return hybrid(player, card, event);  
}

int card_ashenmoor_gouger(int player, int card, event_t event){
    cannot_block(player, card, event);
    return hybrid(player, card, event);  
}

int card_wilt_leaf_liege(int player, int card, event_t event){
    if( event == EVENT_POWER || event == EVENT_TOUGHNESS ){
        if( affected_card_controller == player && ! affect_me(player, card) && in_play(player, card) ){
            //card_instance_t *affected = get_card_instance( affected_card_controller, affected_card );
            int color = get_color(affected_card_controller, affected_card);
            if( color & COLOR_TEST_GREEN ){
                event_result++;
            }
            if( color & COLOR_TEST_WHITE ){
                event_result++;
            }
        }
    }
    return hybrid(player, card, event);  
}

int card_kitchen_finks(int player, int card, event_t event){
    hybrid(player, card, event);
    
    card_instance_t *instance = get_card_instance( player, card);
    if( comes_into_play(player, card, event) == 1 ){
        gain_life(player, 2);
    }
    
    // if this dies, return it to play
    if(event == EVENT_GRAVEYARD_FROM_PLAY){
        if( affect_me( player, card) && in_play(player, card) ){
            if(instance->kill_code != KILL_REMOVE && instance->counter_power >= 0  ){
                int card_added = add_card_to_hand( player, get_internal_card_id_from_csv_id( get_id(player, card) ) );
                put_into_play(player, card_added);
                card_instance_t *new_instance = get_card_instance( player, card_added);
                new_instance->counters = 1;
                new_instance->counter_power--;
                new_instance->counter_toughness--; 
                instance->kill_code = KILL_REMOVE;
            }
        }
    }
    return 0;
}

int card_demigod_of_revenge(int player, int card, event_t event){
    hybrid(player, card, event);
    haste(player, card);
    if( event == EVENT_CAST_SPELL && affect_me(player, card) && cancel != 1 ){
        int *graveyard = graveyard_ptr[player];
        int i;
        int id = get_id(player, card);
        for(i = 0; i < count_graveyard(player); i++){
            if( cards_data[  graveyard[i] ].id == id  ){
                remove_card_from_grave(player, i); 
                int card_added = add_card_to_hand( player, get_internal_card_id_from_csv_id( id ) );
                put_into_play(player, card_added);
                i--;
            }
        }
    }
    return 0;
}

int card_fulminator_mage(int player, int card, event_t event){
    hybrid(player, card, event);
    card_instance_t *instance = get_card_instance(player, card);
    target_definition_t td;
    default_target_definition(player, card, &td, TYPE_LAND);
    if(event == EVENT_CAN_ACTIVATE ){
        int p = 0;
        for(p=0;p<2;p++){
            int count = 0;
            while(count < active_cards_count[p]){
                card_data_t card_d = get_card_data(p, count);
                if( (card_d.type & TYPE_LAND)  && in_play(p, count) && ! is_basic_land(p, count) ){
                    return 1;
                }
                count++;
            }
        }
    }
    else if( event == EVENT_ACTIVATE ){
        while(1){
            if( ! select_target(player, card, &td, "Choose a nonbasic land.", NULL) ){
                spell_fizzled = 1;
                break;
            }
            if(! is_basic_land(instance->targets[0].player, instance->targets[0].card)){
                instance->info_slot = 1;
                kill_card(player, card, KILL_SACRIFICE);
                break;
            }
        }
    }
    else if(event == EVENT_RESOLVE_ACTIVATION ){
        instance = get_card_instance(player, card);
        if( instance->info_slot == 1 && validate_target(player, card, &td, 0) ){
            kill_card(instance->targets[0].player, instance->targets[0].card, KILL_DESTROY);
        }
        return 0;
    }
    else{
        return mana_producer(player, card, event);
    }
    return 0;
}
